VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   BackColor       =   &H8000000C&
   Caption         =   "RgbView 1.0 by Dmitry Brant"
   ClientHeight    =   5145
   ClientLeft      =   165
   ClientTop       =   765
   ClientWidth     =   6735
   LinkTopic       =   "Form1"
   ScaleHeight     =   343
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   449
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BackColor       =   &H8000000C&
      BorderStyle     =   0  'None
      Height          =   285
      Left            =   0
      ScaleHeight     =   19
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   25
      TabIndex        =   0
      Top             =   0
      Width           =   375
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   495
      Top             =   45
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuOpen 
         Caption         =   "&Open"
      End
      Begin VB.Menu mnuSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuAbout 
         Caption         =   "&About..."
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'For Copyright information, read the comments
'in the Module file (.BAS)

Option Explicit
Dim prevX, prevY As Single
Dim mouseIsDown As Boolean

Private Sub Form_Unload(Cancel As Integer)
    Close
    End
End Sub

Private Sub mnuAbout_Click()
MsgBox "RgbView 1.0 by Dmitry Brant (me@dmitrybrant.com)" + vbCrLf + "A complete RGB / BW decoder written entirely in VB." + _
        vbCrLf + vbCrLf + "Copyright 2003 by Dmitry Brant, All Rights Reserved." + _
        vbCrLf + vbCrLf + "http://www.dmitrybrant.com", vbInformation, "About..."
End Sub

Private Sub mnuExit_Click()
    Close
    End
End Sub

Private Sub mnuOpen_Click()
Dim sFilter As String
    On Error GoTo ErrHandler
    CommonDialog1.DialogTitle = "Select a RGB Image"
    sFilter = "RGB Images (*.bw, *.rgb)|*.bw; *.rgb"
    sFilter = sFilter & "|All Files (*.*)|*.*"
    CommonDialog1.Filter = sFilter
    CommonDialog1.ShowOpen
    Picture1.Refresh
    mnuOpen.Enabled = False
    Picture1.Cls
    DoRGB CommonDialog1.FileName, Picture1
    Picture1.Refresh
    mnuOpen.Enabled = True
    Beep
ErrHandler:
' User pressed Cancel button.
End Sub


Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    mouseIsDown = True
    prevX = X
    prevY = Y
End Sub

Private Sub Picture1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim dx, dy As Integer
    Static justMoved As Boolean
    If mouseIsDown = False Then Exit Sub
    If justMoved Then
        justMoved = False
        prevX = X
        prevY = Y
        Exit Sub
    End If
    dx = X - prevX
    dy = Y - prevY
    prevX = X
    prevY = Y
    If dx = 0 And dy = 0 Then Exit Sub
    justMoved = True
    If dx <> 0 Then
        If dx > 0 Then
            If Picture1.Left + dx < 0 Then
                Picture1.Left = Picture1.Left + dx
            Else
                Picture1.Left = 0
            End If
        Else
            If Picture1.Width > ScaleWidth Then
                If Picture1.Left + Picture1.Width + dx > ScaleWidth Then
                    Picture1.Left = Picture1.Left + dx
                Else
                    Picture1.Left = ScaleWidth - Picture1.Width
                End If
            End If
        End If
    End If

    If dy <> 0 Then
        If dy > 0 Then
            If Picture1.Top + dy < 0 Then
                Picture1.Top = Picture1.Top + dy
            Else
                Picture1.Top = 0
            End If
        Else
            If Picture1.Height > ScaleHeight Then
                If Picture1.Top + Picture1.Height + dy > ScaleHeight Then
                    Picture1.Top = Picture1.Top + dy
                Else
                    Picture1.Top = ScaleHeight - Picture1.Height
                End If
            End If
        End If
    End If
End Sub

Private Sub Picture1_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    mouseIsDown = False
End Sub

Private Sub Form_Resize()
    If Picture1.Left < 0 Then
        If Picture1.Left + Picture1.Width < ScaleWidth Then
            If ScaleWidth - Picture1.Width < 0 Then
                Picture1.Left = ScaleWidth - Picture1.Width
            Else
                Picture1.Left = 0
            End If
        End If
    End If
    If Picture1.Top < 0 Then
        If Picture1.Top + Picture1.Height < ScaleHeight Then
            If ScaleHeight - Picture1.Height < 0 Then
                Picture1.Top = ScaleHeight - Picture1.Height
            Else
                Picture1.Top = 0
            End If
        End If
    End If
End Sub

